/*
 *		DANS UN LIEU INCONNU
 *
 *	essai sur la vision interieur d'un batiment
 *
 *	un projet de tTh né à Valensole été 2021 :)
 *
 *		les decorations
 */

/*    ======================================================    */
/*    ======================================================    */
/*
 *	nouveau de l'été 2023, puis laissé en plan pendant
 *	des mois, et finalement exposé début février 2024
 */
#declare BouncingBall_noyau = object
{
sphere { <0, 0, 0>, 0.05+0.14*cos(clock) }
texture { MON_ROUGE_INDUS scale 0.3333 }
rotate -y*(clock*7)
}

#declare BouncingBall_bulle= object
{
#local Ck = NormClock * 14.50;
#local Sx = 1.3 + 0.70*(sin(Ck) + cos(Ck*4));
#local Sy = 1.1 + sin(Ck + 1.222 );
#local Sz = 1.2 + (sin(Ck * 3) * sin(Ck*5)) ;

sphere { <0, 0, 0>, 0.20 scale <Sx, Sy, Sz> }
texture { TURQ_BOZO rotate y*clock }
}

#declare BouncingBall_vase = object
{
#local RV = 0.79;
#local EV = 0.05;
merge	{
	torus { RV, EV }
	difference {
		sphere { 0, RV+EV }
		sphere { 0, RV-EV }
		box { <-4, 0, -4>, <4, 4, 4> }
		}
	sphere { 0, RV-EV scale <1, 0.25, 1> translate -y*(RV+EV) }
	scale <1, 0.765, 1>
	texture {
		pigment {
			gradient y
#include "volcanomap.incc"
			turbulence 0.43		/* clock dependant maybe */
			scale 0.080
			// rotate -y*(clock*7.89)
			}
		} // fin texture
	}
	
translate y*(RV+0.05)
}

#declare BouncingBall = object
{
union	{
	object { BouncingBall_vase	}
	union	{
		object { BouncingBall_noyau	}
		object { BouncingBall_bulle	}
		#declare Dx = 0;
		#declare Dy = 0.74 + (abs(sin(Ck*2.833)*0.85));
		#declare Dz = 0;
		translate <Dx, Dy, Dz>
		}
	}
}

#declare La_BouncingBall = object
{
union	{
	object { BouncingBall translate y*(H_base-0.20) }
	object { Support_Pierre }
	object { Lampe_Expo rotate  y*172  translate <-1.31, 0, -1.35> }
	}
}

/*    ======================================================    */
/*
 *		TRASHY EXPERIMENT 
 *
 * http://www.f-lohmueller.de/pov_tut/all_shapes/shapes570e.htm
 */

#declare Parametric_A  = object
{

parametric {
  function { sin(u)+sin(v*(0.5+NormClock)*pi) } 	// x(u,v)
  function { cos((u+NormClock)*0.87) }			// y(u,v)
  function { v }					// z(u,v)
  <0,-2>, <2*pi,2> 					// start, end(u,v)
  contained_by {box {<-2,-2,-2>,<2,2,2>}}
  max_gradient 9
  accuracy 0.02				// was 0.05
  precompute 19 x,y,z

	texture {
		#local RA = NormClock;
		#local GA = Cos_010(NormClock);
		#local BA = 1.0 - NormClock;
		pigment { color rgb <RA, GA, BA> }
		finish { phong PHONG specular SPECULAR }
		}
  } // end of parametric ------
}

#declare Squelette_Param = object
{
#local DS = 1.50;
#local RS = 0.10;
#local RB = 0.04;
merge	{
	sphere { 0, RS*2.5 }
	sphere { <-DS, -DS, -DS>,  RS			}
	sphere { < DS, -DS, -DS>,  RS			}
	sphere { <-DS, -DS,  DS>,  RS			}
	sphere { < DS, -DS,  DS>,  RS			}
	sphere { <-DS,  DS, -DS>,  RS			}
	sphere { < DS,  DS, -DS>,  RS			}
	sphere { <-DS,  DS,  DS>,  RS			}
	sphere { < DS,  DS,  DS>,  RS			}

	cylinder { < DS,  DS,  DS>, <-DS, -DS, -DS>, RB	}
	cylinder { < DS, -DS,  DS>, <-DS,  DS, -DS>, RB	}
	cylinder { < DS,  DS, -DS>, <-DS, -DS,  DS>, RB	}
	cylinder { <-DS,  DS,  DS>, < DS, -DS, -DS>, RB	}
	}

texture {
	pigment { color Gray70 }
	finish { phong PHONG specular 0.02 reflection 0.12 }
	}
}

#declare Parametric = object
{
union	{
	object { Parametric_A			 }
	object { Squelette_Param		 }
	}	
rotate x*80
rotate -y*(clock*1.48)
scale 0.369
translate 0.90*y
}

#declare Le_Parametric_A  = object
{
union	{
	object { Lampe_Expo	rotate  y*90	translate < 1.31, 0, -1.35> }

	object { Base_Ronde_Pieds }
	object { Parametric	translate y*(0.10+H_base) }
	}
}

/*    ============================================================    */
/*	objet inventé vers le 15 mai 2022			*/

#declare Forme_Complexe = object
{
#local FCR = 0.20;
#local SCF = 1.80 + (Cos_010(NormClock) * 1.666);
#local API = NormClock * 3.141592654 * 11.0;
#local K   = 0.61 + NormClock;
#declare SCX = (rand(RND)) + SCF + (K * cos(API));
#declare SCY = (rand(RND)) + SCF + (K * cos(API+1.57));
#declare SCZ = (rand(RND)) + SCF + (K * cos(API+3.14));

#ifdef (LOG_RANDOM)
  #fopen FD "WS/cmplx.log" append
  #write (FD    clock, " ", SCX, " ", SCY, " ", SCZ, "\n")
  #fclose FD
#end 

merge	{
	sphere { 0, FCR scale <SCX, 1, 1> }
	sphere { 0, FCR scale <1, SCY, 1> }
	sphere { 0, FCR scale <1, 1, SCZ> }
	}
}

#declare Chose_Complexe_a = object
{
object {
	Forme_Complexe
	texture {
		pigment { color <0.55, 0.48, 0.24> }
		normal { granite 0.22 scale 0.89 }
		finish { ambient 0.28 phong 0.58 metallic 0.50 }
		}
	}
}

#declare Chose_Complexe_b = object
{
#local Rtore = 0.018;
merge	{
	torus { SCF/4, Rtore }
	torus { SCF/4, Rtore rotate x*90 }
	torus { SCF/4, Rtore rotate z*90 }
	}
texture { GRIS_BROTCH rotate clock }
#undef Rtore
}

#declare Chose_Complexe_angle = object
{
difference {
	box { <0.02,  0,    0.02>, <0.15, 0.40, 0.35> }
	box { <0.04, -1,    0.04>, <0.36, 0.46, 0.46> }
	}
}
#declare Chose_Complexe_base = object
{
#local SB = SCF * 0.30;
union	{
	box { <-SB, 0, -SB>, <SB, 0.03, SB> }
	object { Chose_Complexe_angle rotate   0*y translate <-SB, 0, -SB> }
	object { Chose_Complexe_angle rotate 270*y translate < SB, 0, -SB> }
	object { Chose_Complexe_angle rotate  90*y translate <-SB, 0,  SB> }
	object { Chose_Complexe_angle rotate 180*y translate < SB, 0,  SB> }
	}
texture { GRIS_BROTCH scale 2.275 }
}

#declare Chose_Complexe_c = object
{
#local Rtore = 0.040;
merge	{
	torus { SCF/4, Rtore }
	torus { SCF/4, Rtore rotate x*90 }
	torus { SCF/4, Rtore rotate z*90 }
	}
// texture { GRIS_BROTCH rotate clock }
#undef Rtore
}

#declare Chose_Complexe = object
{
union	{
	union	{
		difference {
			object { Chose_Complexe_a }
			object { Chose_Complexe_c }
			}
		object { Chose_Complexe_b }
		rotate <9, 11, 9>
		translate y*1.10
		}
	object { Chose_Complexe_base }
	}
}

#declare La_Chose_Complexe = object
{
union	{
	object { Chose_Complexe rotate 45*y translate <0.01, H_base, -0.02> }
	object { Seconde_Base }
	}
}

/*    ============================================================    */

#declare Bouncer_Body = object
{
intersection {
	difference {
		sphere { <0, 0, 0>, 0.35 }
		sphere { <0, 0, 0>, 0.31 }
		 scale <1, 1.899, 1> 
		}
	box { <-5, 0, -5>, <5, 5, 5> }
	}
}
#declare Bouncer_Base = object
{
union	{
	#local Kr = 1.90;
	cylinder { <0, 0, 0>, <0, 0.02, 0>, 0.40*Kr }
	cylinder { <0, 0, 0>, <0, 0.05, 0>, 0.30*Kr }
	cylinder { <0, 0, 0>, <0, 0.08, 0>, 0.20*Kr }
	}
}

#declare H_bouncer = 0.90;

#declare Bouncer_Support = object
{
union	{
	#for (foo, 0, 360, 72)
	  #local Dxb = 0.79 * cos(radians(foo));
	  #local Dzb = 0.79 * sin(radians(foo));
	  sphere { 0, 0.18 scale <1, 0.6, 1> translate <Dxb, 0, Dzb> }
	  #local Dxh = 0.33 * cos(radians(foo));
	  #local Dzh = 0.33 * sin(radians(foo));
	  cylinder { <Dxb, 0, Dzb>, <Dxh, H_bouncer, Dzh>, 0.03 }
	#end
	}
}

#declare The_Bouncer = object
{
#local H = abs(sin(radians(clock*5))) * 1.932;
union	{
	object { Bouncer_Body
		rotate x*(23*sin(radians(clock*13)))
		translate (H_bouncer+0.22+H)*y
		}
	object { Bouncer_Base translate (H_bouncer+0.03)*y }
	object { Bouncer_Support }
	}
texture {
	pigment { color Gray50 }
	finish  { LOL_FINISH   }
	}
// translate y*0.20
}
/* XXX this element need more work ! */

/*    ============================================================    */

#declare D_struct = 0.57;

#declare Un_Coin_Structure = object
{
#local D = 0.085;
difference {
	box { <-D, -D, -D>, <D, D, D> }
	#local d2 = D+0.11;
	#local r2 = D*0.71;
	cylinder { <-d2, 0, 0>, <d2, 0, 0>, r2 }
	cylinder { <0, -d2, 0>, <0, d2, 0>, r2 }
	cylinder { <0, 0, -d2>, <0, 0, d2>, r2 }
	}
}

#declare Coins_Structure = object
{
union	{
	#local D = D_struct;
	/* bas */
	object { Un_Coin_Structure translate <-D, -D, -D> }
	object { Un_Coin_Structure translate < D, -D, -D> }
	object { Un_Coin_Structure translate <-D, -D,  D> }
	object { Un_Coin_Structure translate < D, -D,  D> }
	/* haut */
	object { Un_Coin_Structure translate <-D,  D, -D> }
	object { Un_Coin_Structure translate < D,  D, -D> }
	object { Un_Coin_Structure translate <-D,  D,  D> }
	object { Un_Coin_Structure translate < D,  D,  D> }
	}
texture { TURQ_BOZO scale 4 }
}

#declare Barres_Structure = object
{
union	{
	#local R = 0.037;
	#local D2 = D + 0.20;
	/* bas */
	cylinder { <-D, -D, -D2>, <-D, -D,  D2>, R }
	cylinder { < D, -D, -D2>, < D, -D,  D2>, R }
	cylinder { < D2, -D,  D>, <-D2, -D,  D>, R }
	cylinder { < D2, -D, -D>, <-D2, -D, -D>, R }
	#local r2 = R * 2.1;
	sphere { <-D, -D, -D>, r2 }
	sphere { < D, -D, -D>, r2 }
	sphere { <-D, -D,  D>, r2 }
	sphere { < D, -D,  D>, r2 }

	/* vertical */
	cylinder { <-D, -D2, -D>, <-D,  D2, -D>, R }
	cylinder { < D, -D2, -D>, < D,  D2, -D>, R }
	cylinder { <-D, -D2,  D>, <-D,  D2,  D>, R }
	cylinder { < D, -D2,  D>, < D,  D2,  D>, R }

	/* haut */
	cylinder { <-D,  D, -D2>, <-D,  D,  D2>, R }
	cylinder { < D,  D, -D2>, < D,  D,  D2>, R }
	cylinder { < D2,  D,  D>, <-D2,  D,  D>, R }
	cylinder { < D2,  D, -D>, <-D2,  D, -D>, R }
	sphere { <-D,  D, -D>, r2 }
	sphere { < D,  D, -D>, r2 }
	sphere { <-D,  D,  D>, r2 }
	sphere { < D,  D,  D>, r2 }
	}
texture { ROSE_BIZARRE scale 4.99 }
}

#declare Boule_Structure = object
{
difference {
	#local delta = 0.51 + 0.265*sin(NormClock*3.14159*28);
	#local ra = D_struct * delta;
	#local rb = ra - 0.03;
	sphere { 0, ra }
	sphere { 0, rb }		// decoupe interieur

	#local rc = ra + 0.04;
	#local rd = delta * 0.175;
	cylinder { <-rc, -rc, -rc>, < rc,  rc,  rc>, rd }
	cylinder { < rc, -rc, -rc>, <-rc,  rc,  rc>, rd }
	cylinder { < rc, -rc,  rc>, <-rc,  rc, -rc>, rd }
	cylinder { <-rc, -rc,  rc>, < rc,  rc, -rc>, rd }
	}
rotate x*clock
texture { MON_VERT_INDUS scale 0.28 }
}

#declare Structure = object
{
union	{
	object { Coins_Structure }
	object { Barres_Structure }
	object { Boule_Structure }
	}
}

#declare La_Structure = object
{
union	{
	object { Base_Machins }
	object { Structure	rotate <3, 12, 5>	translate 1.58*y }
	object { Lampe_Expo     rotate  y*93	translate < 1.45, 0, -1.4> }
	}
}

/*    ============================================================    */

#declare TextureLab = object
{
/* scaling some textures */
#local MVI = texture { MON_VERT_INDUS scale 0.25 }
#local PKL = texture { PinkAlabaster scale 0.05 }
#local SW  = texture { Sandalwood scale 0.46 }
#local RST = texture { Rust scale 0.6+Cos_010(NormClock) }
#local LG1 = texture { Lightning1 scale 0.222 rotate x*clock }
#local WAT = texture { Water scale 0.75 }

#local E = 0.36;

union	{
	object { Table_Stand }
	/*
	 * "Un_Bidule" défini dans elements.inc
	 */
	#local H = H_stand + 0.18;
	object { Un_Bidule(ROSE_BIZARRE, MVI) translate <-E, H, -E> }
	object { Un_Bidule(PKL, TURQ_BOZO)    translate < E, H, -E> }
	object { Un_Bidule(SW , RST)          translate <-E, H,  E> }
	object { Un_Bidule(WAT, LG1)          translate < E, H,  E> }
	#undef H
	}
}

/*    ============================================================    */

#declare Une_Bulle = object
{
#local R_bulle = 0.32;
difference {
	#local R2 = R_bulle * 1.42;
	#local R3 = 0.15;
	sphere { 0, R_bulle }
	torus { R2, R3 }
	torus { R2, R3 rotate x*90 }
	torus { R2, R3 rotate z*90 }
	}
// rotate <13, 15, 17>
}

#declare Decoupe_Bulles = object
{
union	{
	#local N = 2;
	#local K = 3 + (NormClock*222);
	#for (pX, -N, N)
	  #for (pY, -N, N)
	    #for (pZ, -N, N)
	      object { Une_Bulle
		rotate <pX*K, pY*K, pZ*K> 
		translate <pX, pY, pZ> }
	    #end
	  #end
	#end
	}
scale 0.2222
}

#declare Decoupe_Cube = object
{
#local D = 0.60;
difference {
	box { <-D, -D, -D>, <D, D, D> }
	#local D2 = D * 1.02;

	#local nc2 = mod(NormClock*6, 2);
	#local R2 = 0.014 + (Cos_010(nc2) * 1.30);

	sphere { <-D2, D2, -D2>, R2 }
	sphere { < D2, D2,  D2>, R2 }
	sphere { < D2, D2, -D2>, R2 }
	sphere { <-D2, D2,  D2>, R2 }
	}
texture { MON_ROUGE_INDUS rotate <9, NormClock*24, 7> scale <0.2, 0.9, 0.2> }
}

#declare Cube_Bulles = object
{
union	{
	object { Decoupe_Cube }
	object {
		Decoupe_Bulles
		texture { ROSE_BIZARRE scale 2.75 }
		}
	}
}

#declare Dalle_Grise = object
{
#local HDG= 0.12;		/* hauteur */
#local SDG = 0.70;
#local SD2 = SDG + 0.1;
difference {
	box { <-SDG, 0, -SDG>, <SDG, HDG, SDG> }
	cylinder { <-SD2, HDG, -SDG>, < SD2, HDG, -SDG>, 0.02 }
	cylinder { <-SD2, HDG,  SDG>, < SD2, HDG,  SDG>, 0.02 }
	cylinder { <-SDG, HDG, -SD2>, <-SDG, HDG,  SD2>, 0.02 }
	cylinder { < SDG, HDG, -SD2>, < SDG, HDG,  SD2>, 0.02 }
	}
texture {
	pigment { color Gray30 }
	normal { dents 0.12 scale 0.35 }
	finish { phong PHONG  specular SPECULAR }
	}
}
#declare Le_Cube_Bulles = object
{
union	{
	object { Base_Machins }
	object { Dalle_Grise rotate -1*y translate y*H_base }
	object { Cube_Bulles translate y*(H_base+0.74) }
	object { BiLampe translate 1.58*z }
	}
}

/*    ============================================================    */

#local Gam = 1.28 + 1.24*sin(NormClock*64);

#declare Champ_Altitude = object
{
height_field {
	png "WS/hf5.png" gamma Gam
	smooth    // on
	translate <-0.5, 0, -0.5>
	scale <1.27, 1.45, 1.27>
	}
texture {
	pigment { color Gray50+<0, 0, 0.27> }
	finish { phong PHONG  specular SPECULAR
		emission 0 	reflection 0.60 }
	}
}

#declare Jauge_Gamma = object
{
cylinder { <0, 0, 0>, <0, 1.0, 0>, 0.02 }
pigment { color rgb <0.40, 0.75, 0.35> }
}

#declare Le_Champ_Altitude = object
{
union	{
	object { Table_Stand }
	object { Champ_Altitude rotate 2.9*y translate y*(0.025+H_stand) }
	object { Jauge_Gamma    translate <0.64, (H_stand), 0.64> }
	}
}


/*    ============================================================    */

#declare MultiTore_les_tores = object
{
#local Dt1 = 0.40;
#local Dt2 = 0.03;
union	{
	#local Clk = clock * 1.2;
	#local Scl = <1, 1.5, 1>;
	torus { Dt1*0.9, Dt2      scale Scl rotate x*(Clk*3) }
	torus { Dt1*0.7, Dt2*0.8  scale Scl rotate x*(Clk*5) }
	torus { Dt1*0.5, Dt2*0.7  scale Scl rotate x*(Clk*7) }
	torus { Dt1*0.3, Dt2*0.6  scale Scl rotate x*(Clk*10) }
	}
// texture { CYAN_CRACRA }
texture {
	pigment { color Gray80 }
	finish { phong PHONG  specular SPECULAR reflection 0.75 }
	}
}

#declare MultiTore_B = object
{
union	{
	#local Lt = Dt1*1.2;
	#local La = Lt + 0.26;
	torus { Lt, Dt2*0.75	rotate x*90 }
	torus { Lt, Dt2*0.75	rotate y*90 }
	torus { Lt, Dt2*0.75	rotate z*90 }
	cylinder { <-La, 0, 0>, <La, 0, 0>, Dt2*1.22 }
	sphere   { <-La, 0, 0>, Dt2*1.27 }
	sphere   { < La, 0, 0>, Dt2*1.27 }
	}
texture {
	pigment { color Orange }
	finish { phong PHONG  specular SPECULAR reflection 0.35 }
	}
}

#local H_smt   = 0.50;
#local EX_smt  = 0.60;
#local EZ_smt  = 0.35;
#local R_smt   = 0.033;

#declare Support_MultiTore_A = object
{
union	{
	difference {
	  torus { EZ_smt, R_smt rotate z*90 }
	  box { <-1, 0, -1>, <1, -2, 1> }
	  translate y*H_smt
	  }
	cylinder { <0, 0, -EZ_smt>, <0, H_smt, -EZ_smt>,  R_smt }
	cylinder { <0, 0, -EZ_smt>, <0, 0.03,  -EZ_smt>,  R_smt*2.22222 }
	cylinder { <0, 0,  EZ_smt>, <0, H_smt,  EZ_smt>,  R_smt }
	cylinder { <0, 0,  EZ_smt>, <0, 0.04,   EZ_smt>,  R_smt*2.22222 }
	/* le palier */
	cylinder { <-0.05, H_smt+EZ_smt, 0>,
			<0.05, H_smt+EZ_smt, 0>, 0.06 }
	}
}
#declare Support_MultiTore = object
{
union	{
	object { Support_MultiTore_A translate -x*EX_smt }
	object { Support_MultiTore_A translate  x*EX_smt }
	}
texture {
	pigment { color rgb <0.40, 0.40, 0.45> }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare MultiTore = object
{
union	{
	union	{
		object { MultiTore_les_tores }
		object { MultiTore_B }
		translate y*(H_smt+EZ_smt)
		}
	object { Support_MultiTore }
	}
}
#declare Stand_MultiTore = object
{
union	{
	object { Table_Stand }
	object { MultiTore rotate y*92 translate H_stand*y }
	}
}

/*    ============================================================    */

#declare Julia_0 = object
{
julia_fractal {
	#local A = Cos_010(NormClock*3.333)*0.8 - 0.25;
	#local B = 0.20 * sin(NormClock*36);
	#local C = -0.920+(NormClock*1.95);
	#local D = abs(sin(NormClock*49)) - 0.45;
        <A, B, C, D>
        quaternion      cube
        max_iteration   29
        precision       29
        }

texture {
	#local R = 0.05+(NormClock*0.90);
	#local B = 0.95-(NormClock*0.90);
	pigment { color <R, 0.3333, B> }
	finish	{
		phong 0.12
		specular 0.22
		reflection 0.42
		emission 0.180
		}
	}
rotate z*90
scale <0.77, 1.07, 0.79>
}

#declare La_Julia = object
{
union	{
	object { Julia_0 rotate y*19 translate y*1.80  }
	object { Base_Machins }
	}
}

/*    ============================================================    */

#declare Anneau_0_jante = object
{
#local DA = 0.885;
#local db = 0.060;
#local Ej = 0.06;	// epaisseur jante
difference {
	cylinder { <-Ej, 0, 0>, <Ej, 0, 0>, DA+db }
	cylinder { <-0.12, 0, 0>, <0.12, 0, 0>, DA-db }
	#for (foo, 0, 360, 8.57142857142857)
		#local bar = radians(foo);
		#local dy = DA * sin(bar);
		#local dz = DA * cos(bar);
		sphere { 0, 0.06 translate <-0.111, dy, dz> }
		sphere { 0, 0.06 translate < 0.111, dy, dz> }
	#end
	}
texture {
	pigment { color <0.12, 0.01, 0.48> }
	finish { phong PHONG specular SPECULAR }
	}
}


#declare Anneau_0_moyeu = object
{
difference {
	#local Ra = 0.16;
	#local Rb = 0.11;
	union	{
		cylinder { <-0.15, 0, 0>, <0.15, 0, 0>, Ra	}
		sphere   { <-0.15, 0, 0>, Ra			}
		sphere   { < 0.15, 0, 0>, Ra			}
		}
	cylinder { <-0.40, 0, 0>, <0.40, 0, 0>, Rb }
	}
texture {
	pigment { color <0.12, 0.01, 0.46> }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Anneau_0_rayons = object
{
union	{
	#local Ex = 0.14;
	#local flag = 0;
	#for (foo, 0, 360, 8.571428571)
	  #local Ca = DA * cos(radians(foo));
	  #local Sa = DA * sin(radians(foo));
	  #local Cb = 0.15 * cos(radians(foo));
	  #local Sb = 0.15 * sin(radians(foo));
	  #if (flag)
	    #local Ex2 = Ex;
	    #local flag = 0;
	  #else
	    #local Ex2 = -Ex;
	    #local flag = 1;
	  #end
	cylinder { <0, Ca, Sa>, <Ex2, Cb, Sb>, 0.010 }
	#end
	}
texture {
	pigment { color <0.34, 0.15, 0.46> }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Anneau_0 = object
{
union	{
	object { Anneau_0_jante }
	object { Anneau_0_moyeu }
	object { Anneau_0_rayons }
	}
rotate y*(clock*1.01) 
}

/*    ============================================================    */

#declare Premier_Anneau = object
{
union	{
	object { Anneau_0 translate y*1.66 }
	object { Base_Ronde }
	}
}
/*    ============================================================    */
// ----------------------------------------------------------
// nouveau valensole debut aout 2021

#declare D_ld = 0.50;

#declare Verre_Lentille_Convergente = object
{
intersection {
	box { <-D_ld, 0, -D_ld>, <D_ld, 0.20, D_ld> }
	#local RS = 2.00;
	#local HS = RS - 0.17;
	sphere { <0, -HS, 0>, RS }
	}
texture { Glass3 }
interior { I_Glass }
}

#declare Verre_Lentille_Divergente = object
{
difference {
	box { <-D_ld, 0, -D_ld>, <D_ld, 0.20, D_ld> }
	#local RS = 2.00;
	#local HS = RS + 0.03;
	sphere { <0, HS, 0>, RS }
	}
texture { Glass3 }
interior { I_Glass }
}

#declare Cadre_Lentille = object
{
difference {
	#local d2 = D_ld + 0.04;
	#local d3 = D_ld + 0.02;

	box { <-d2, -0.01, -d2>, <d2, 0.18, d2> }
	box { <-d3, -1, -d3>,    <d3, 1, d3> }
	}
texture {
	pigment { color Gray50 }
	normal { bumps 0.25 scale 0.14 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare H_ld = 1.60;

#declare Pied_Lentille_Divergente_a = object
{
union	{
	#local R_p = 0.026;
	#local E_P = 0.45;
	#local H2  = 0.28;
	#local H3  = 0.10;
	#local RS  = R_p * 1.395;

	/* partie verticale */
	sphere { <0, H_ld, 0>, R_p }
	cylinder { <0, 0, 0>, <0, H_ld, 0>, R_p }
	cylinder { <0, 0, 0>, <0, 0.02, 0>, R_p*2.6 }

	sphere { <0, H2, 0>, RS }
	// cylinder { <0, H2, -E_P>, <0, H2, E_P>, R_p }

	/* ---- un pied lateral ---- */
	sphere   { <0, H3, -E_P>, RS }
	cylinder { <0, H2,   0>, <0, H3, -E_P>, R_p }
	sphere   { <0, H3,  E_P>, RS }
	cylinder { <0, H2,   0>, <0, H3,  E_P>, R_p }
	/* partie verticale au bout */
	cylinder { <0, 0, -E_P>, <0,  H3,  -E_P>, R_p }
	cylinder { <0, 0, -E_P>, <0, 0.02, -E_P>, R_p*2.6 }
	cylinder { <0, 0,  E_P>, <0,   H3,  E_P>, R_p }
	cylinder { <0, 0,  E_P>, <0, 0.02,  E_P>, R_p*2.6 }
	}
texture {
	pigment { color Gray40 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Pied_Lentille = object
{
union {
	#local DX = D_ld + 0.06;
	object { Pied_Lentille_Divergente_a translate -DX*x }
	object { Pied_Lentille_Divergente_a translate  DX*x }
	}
}

#declare Lentille_Divergente_optique = object
{
union	{
	object { Cadre_Lentille }
	object { Verre_Lentille_Divergente }
	}
translate -0.06*y		// valeur empirique
rotate -1*x			// ???
rotate x*90
}

#declare Lentille_Convergente_optique = object
{
union	{
	object { Cadre_Lentille }
	object { Verre_Lentille_Convergente }
	}
translate -0.06*y		// valeur empirique
rotate 2*x			// ??? again...
rotate x*90
}
/*    ============================================================    */

#declare Lentille_Divergente = object
{
union {
	object { Lentille_Divergente_optique translate y*(H_ld) }
	object { Pied_Lentille }
	}
}

#declare Lentille_Convergente = object
{
union {
	object { Lentille_Convergente_optique translate y*(H_ld) }
	object { Pied_Lentille }
	}
}

/*    ============================================================    */
/* ----------------------------------------------------------	      */
// nouveau valensole 27 juin 2021

#declare R_miroir = 0.633;

#declare Miroir_Verre = object
{
cylinder { <0, 0, 0>, <0, 0.015, 0>, R_miroir*0.99 }
texture  {
	pigment { color Gray80 }
	finish { ambient 0 diffuse 0 reflection 0.87 }
	}
}

#declare Miroir_Cercle = object
{
torus { R_miroir, 0.0170 scale <1, 1.5, 1> }
texture {
	pigment { color <0.12, 0.42, 0.16> }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Support_Miroir_Rond = object
{
difference {
	cylinder { <0, -0.04, 0>, <0, 0.04, 0>, R_miroir + 0.06 }
	cylinder { <0, -0.05, 0>, <0, 0.05, 0>, R_miroir + 0.02 }
	}
rotate    x*90
texture {
	pigment { color Gray50 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Miroir_Rond = object
{
union	{
	union	{
		object { Miroir_Verre }
		object { Miroir_Cercle }
		rotate x*(83+14*sin(radians(clock*0.60)))
		}
	object { Support_Miroir_Rond }
	}
translate y*1.70
}

#declare Support_MR_un_pied = object
{
#local EP = 0.75;	// ecart du bout du pied

merge	{
	cylinder { <0, 0.12, EP>, <0, 0.35, 0.00>, 0.03		}
	cylinder { <0, 0.00, EP>, <0, 0.02, EP>    0.08		}
	cylinder { <0, 0.00, EP>, <0, 0.15, EP>    0.05		}
	sphere   { <0, 0.15, EP>		   0.05		}
	}
}

#declare Support_MR_le_pied = object
{
merge	{
	object { Support_MR_un_pied }
	object { Support_MR_un_pied rotate y*120 }
	object { Support_MR_un_pied rotate y*240 }
	cylinder { <0, 0.24, 0>, <0, 1.06, 0>, 0.044 }
	cylinder { <0, 0.29, 0>, <0, 0.40, 0>, 0.052 }
	}
texture {
	pigment { color Gray70 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Miroir_qui_tourne = object
{
union	{
	object { Support_MR_le_pied }
	object { Miroir_Rond rotate -y*(clock*1.47) }
	}
}

/*    ============================================================    */

#declare R_horloge = 1.51;

#declare Point_Heure = object
{
sphere { 0, 0.085
	scale <1, 0.45, 1>
	texture {
		pigment { color Gray30 }
		finish { phong PHONG specular SPECULAR }
		}
	}
}

#declare Cadran = object
{
union	{
	cylinder {
		<0, 0, 0>, <0, 0.01, 0>, R_horloge
		pigment { color White }
		}
	#for (foo, 0, 360, 30)
		#declare R  = R_horloge * 0.80;
		#declare dx = R * sin(radians(foo));
		#declare dz = R * cos(radians(foo));
		object { Point_Heure
			translate <dx, 0.014, dz>
			}
	#end
	torus { R_horloge, 0.039 
		scale <1, 1.25, 1>
		texture {
			pigment { color <0.34, 0.17, 0.56> }
			finish { phong PHONG specular SPECULAR }
			}
		}
	/* le pivot des aiguilles  */
	cylinder { <0, 0, 0>, <0, 0.12, 0>, 0.030 }
	}
}

#declare LaA = 0.058;		// largeur aiguille
#declare HaA = 0.016;		// hauteur aiguille

#declare Grande_Aiguille = object
{
box { <LaA, 0, -0.12>, <-LaA, HaA, R_horloge*0.88> }
texture {
	pigment { color Scarlet }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Petite_Aiguille = object
{
#local La = LaA * 1.200;
box { <La, 0, -0.09>, <-La, HaA, R_horloge*0.5> }
texture {
	pigment { color Scarlet }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Horloge = object
{
// calcul des angles :
#local A_grande = clock * 2.4;
#local A_petite = A_grande / 60;

union	{
	object { Cadran }
	object { Grande_Aiguille rotate y*A_grande translate 0.055*y }
	object { Petite_Aiguille rotate y*A_petite translate 0.075*y }
	}
}

/*    ============================================================    */
/*
 *		les videos affichées sur les murs
 */

/* vision du futur */
#declare Panneau_0 = object
{
#local  IMNUM = mod(clock+357, 2000);
#local  INAME = concat("frames/negatif/", str(IMNUM, -4, 0), ".png");
#debug concat("Retour vers le futur = ", INAME, "\n")

box { <-5.33333, 0, -3>, <5.33333, 0.02, 3> }
pigment {
	image_map { png INAME }
        rotate x*90
        translate <-0.5, 0, -0.5>
        scale <10.66666, 1, 6> 
        }
finish { emission 0.38 }
scale 0.84
}

/*    ============================================================    */
/*
 * 			?	
 */
#declare Film_Roulotte = object
{
#local  IMNUM = mod(clock, 2000);
#local  INAME = concat("frames/gravfield/", str(IMNUM, -5, 0), ".png");
#local  DX = 1024 / (3.0*100);
#local  DZ =  768 / (3.0*100);
box { <-DX, 0, -DZ>, <DX, 0.02, DZ> }
pigment {
 	image_map { png INAME }
        rotate x*90
        translate <-0.5, 0, -0.5>
        scale <-DX*2, 1, DZ*2> 		// XXX
        }
finish { emission 0.56 }
}

/*    ============================================================    */
/*
 *	diffusion sur l'ecran de la rotonde
 */
#declare TimeLapse = object
{
#declare IMNUM = mod(clock, 2000);
#declare INAME = concat("frames/grab/", str(IMNUM, -5, 0), ".png");

#debug concat("    Timelapse image = ", INAME, "\n")

union	{
	box { <-4, 0, -3>, <4, -0.03, 3>
		pigment {
	           image_map { png INAME  interpolate 2 }
	           rotate x*90
	           translate <-0.5, 0, -0.5>
        	   scale <-8, 1, 6>
		   }
		finish { emission 0.59 }
		}
	box { <-4.20, 0, -3.20>, <4.20, 0.03, 3.20> pigment { color Gray50 } }
        }
// scale 0.96
}
/*    ============================================================    */
